
    
#include "colors.inc"
#include "textures.inc"      
#include "consts.inc"
#include "stones.inc" 
#include "glass.inc" 
#include "functions.inc"
#include "dh-herotree.inc"


#declare r_finerend=2;              //what to render
#declare r_radiosity=0;
#declare r_otherplanets=1;
#declare r_athmosphere=1;
#declare r_fakeveget=1;         
#declare r_landsc=1;
#declare r_water=1;
#declare r_planet=1;   
#declare r_objects=1;       
#declare r_trees=1;       
#declare r_zweige=1;

#declare p_radius=200000;            //
#declare p_rotation=<0,0,0>;  //dont affects positions of objects!
#declare cam_pos=<0,500,00>; 
#declare cam_look=<0, 0, 00>;  
#declare cam_look=<-7800,17800,50000>;       //look at moon
#declare cam_look=<11, 13, 00>;                //look at gras
#declare cam_detail=10;                      //detail 25th of size for pov-comp
#declare cam_pos=<0, 50, -40>;    //0,15,-50
#declare cam_look=<0, 40, 00>;       
#declare cam_detail=1;
#declare vx=vrotate(x,p_rotation);      
#declare vy=vrotate(y,p_rotation); 
#declare vz=vrotate(z,p_rotation); 
#declare p_zerovec=vrotate(<0,p_radius,0>,p_rotation)-<0,p_radius,0>;
#declare px=p_zerovec.x;  
#declare py=p_zerovec.y; 
#declare pz=p_zerovec.z;
#declare s_position=<(455-400)/1.86 ,p_radius,(300-267)/1.86>; 
#declare sx=s_position.x;  
#declare sy=s_position.y; 
#declare sz=s_position.z;                

#declare gs_gravity=<0,-.2,0>;                  
#declare gs_memspeed=0;  //0=less memory,slow render 
#declare gs_detailed=1; //0=only cones

 

                       
  #macro posit(vektor)
   #local Norm=<0,0,0>;
   #local vek0=vektor;
   #local vek1=trace(planet,vektor,y,Norm);
   #if (Norm.x != 0 | Norm.y != 0 | Norm.z != 0)
     #local vek0=vek1;
    #else     
     #local vek1=trace(planet,vektor,-y,Norm);;
     #if (Norm.x != 0 | Norm.y != 0 | Norm.z != 0)
      #local vek0=vek1;
     #else     
      #local vek0=(vek0*2+vektor)/3;
     #end
    #end
   vek0
  #end 
  
  #macro positer(vektor)
   #local vek0=posit(vektor);
   #local vek1=posit(vek0+<0,1,0>);
   #if (vek1.y>vek0.y) #local vek0=vek1; #end
   #local vek1=posit(vek1+<0.01,0,0>);
   #if (vek1.y>vek0.y) #local vek0=<vek0.x,vek1.y,vek0.z>; #end
   #local vek1=posit(vek1-<0.02,0,0>);
   #if (vek1.y>vek0.y) #local vek0=<vek0.x,vek1.y,vek0.z>; #end
   #local vek1=posit(vek1+<0.01,0,0.01>);
   #if (vek1.y>vek0.y) #local vek0=<vek0.x,vek1.y,vek0.z>; #end
   #local vek1=posit(vek1-<0,0,0.01>);
   #if (vek1.y>vek0.y) #local vek0=<vek0.x,vek1.y,vek0.z>; #end
   vek0
  #end     
  
    #declare fnWat=   // water shape function
  function{
    pigment {
    bozo
    turbulence 0.0001
    octaves 1
    omega .1
    lambda 1.1
    color_map {
        [0.0 color rgb 0.0]
        [0.2 color rgb 0.5]
        [0.6 color rgb 0.8]
        [1.0 color rgb 1.0]
    }  scale 1   
      translate <0, 0, 0>
    }
  }
 

//   
#declare r_sunpower=7-4*r_athmosphere; 

 // radiosity (global illumination) settings
global_settings {    
max_trace_level   6//4+r_athmosphere*4+r_finerend*2+r_otherplanets*2+r_planet

#if (r_radiosity)
  assumed_gamma 1.5
  radiosity {
    pretrace_start 0.06
    pretrace_end   0.012
    count 150
    always_sample off
    
    nearest_count 8
    error_bound 0.4
    recursion_limit 1

    low_error_factor .4
    gray_threshold 0.0
    minimum_reuse 0.04
    brightness 1
     media on
    adc_bailout 0.05}  }       //.0039
#else 
 adc_bailout 0.05     //.0039     

 
}
/* light_source { cam_pos, color rgb <2,2,2.4>*(1-0.9*r_athmosphere)*.5
  parallel
  point_at cam_look 
  shadowless
  media_interaction off   }    */
#end    
 
  
 
     




camera {                //                The Camera
  location cam_pos
  direction <0, 0, .6*cam_detail>
  sky <0,1,0>
  look_at cam_look
}


  #declare fnear=   // Terrain shape function
  function{pigment {image_map{png "c:\daten\VR\Terra\dance04.png" transmit all 0 filter all 0.8}  }  }      
 
 declare smoothland=blob{
  #declare xcnt=100;
   #while (xcnt>0)     
  #declare ycnt=80;
  #debug concat("  parsing smooth land",str(xcnt,4,0),"\n")
  #while (ycnt>0)   
   #declare srx=.66+xcnt/300; 
   #declare sry=ycnt/240+mod(xcnt,2)/480;
   #declare pos3=<srx,fnear(srx,sry,0).gray/3,sry>;
   //cylinder { <srx,0,sry>,pos3-<0,1/100,0>,1/80,1}
   sphere{pos3-<0,1/150,0>,1/70,1}
   
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end 

scale <.25,3,.25> 
translate <.25,.00,-.5>       
scale <1000,80,1000>
rotate <0,45,0>     
             
 translate <0,p_radius-10,600>   
                         
   }


//
 #declare planet=union{

    // uses image color index as height, extends along X-Z axes
// from <0 0 0> to <1 1 1>

#if (r_landsc)
merge{
difference{
height_field {
  png "c:\daten\VR\Terra\dance0.png"  smooth        // smooth surface normal
translate <-.5,0,-.5>     }
box{<.5,0,-.5>,<.25,1,-.25>}
} 

height_field {
  png "c:\daten\VR\Terra\dance04.png"  smooth        // smooth surface normal

scale <.25,1,.25> 
translate <.25,.00,-.5>       

}    
scale <1000,80,1000>
rotate <0,45,0>     
             
 translate <0,p_radius-10,600>   

  } // merge
#end



object {smoothland}     

sphere  { <0,0,0>,p_radius-90 }    

#if (r_fakeveget)
   texture {
   pigment {      
             bozo              //attention: use same as for fnear (the "height"field)!!
    turbulence 0.9 //.6
    octaves 9      //7
    omega .499
    lambda 2.6  //2.5
        color_map {
        [0.0 color rgb 1]       //attention: zero is top, one is bottom
        [0.2 color rgb 0.3]
        [0.3 color rgb 0.3]
        [0.3 color rgb <0.35,0.3,.25>] 
        [0.4 color rgb <0.30,0.3,.25>]
        [0.41 color rgb <.25,0.23,0.20>]
        [0.5 color rgb <.15,0.25,0.20>]
        [0.51 color rgb <0.25,0.3,0.15>]
        [0.6 color rgb <0.2, 0.3, 0.2>] 
        [0.6 color rgb <.40, 0.4, 0.3>] 
        [0.7 color rgb <.35, 0.4, 0.3>] 
        [1.0 color rgb 0.3] //1]
     } scale 8 }            //attention: use almost the same as for fnear (the "height"field)!!
//  finish { phong .5 phong_size 230 diffuse 0.5 }
  finish { specular 0.06 diffuse 0.12 }
  normal { granite 0.75 scale 0.8  }         //granite 0.15 scale 0.0003 
 }
#else
       pigment { rgb .5}
#end                   

} // union planet

  
                 
  union{                 
light_group{
 
   object{planet}  

difference{                              //dancers
  
height_field {
  png "c:\daten\VR\Terra\dance05-sto.png"     
}    

height_field {
  png "c:\daten\VR\Terra\dance05-stu.png"  
  translate <0,.0001,0>     
}
scale <.0625,.45,.0625> 
translate <.25+.0625*2.5,.3,-.5+.0625*.5>       
 
 scale <1000,80,1000>
rotate <0,45,0>                    
 translate <0,p_radius-10,600>      

  pigment { rgb <.5,.5,.6>*.7}
   finish { specular 0.06 diffuse 0.40 }
  normal { granite 0.55 scale 0.03  }  
 
  
}      
  #local pos1=positer(<(514-512)*2/1.86 ,p_radius+70,(384-406)*2/1.86>)+<0,1,0>;
        
  light_source{ pos1+<0,0,0> color rgb <.05,0.02,.3>*8.0 
      }         
  sphere{ <0,0,0>,1                             //the black shield
    pigment { rgb 0 filter 0 transmit 0}
    finish {reflection 0 diffuse 0 ambient 0 }
    scale <.1,.1,.02>
    translate pos1+<0,0,.2>
  }       
         
#if (r_water)     
  isosurface {
     function { f_sphere(x, y, z, 4.7)+fnWat(x*2, y*4, z*2).gray*.1 }        
    max_gradient 1//2
    accuracy 0.05//.02
    contained_by { sphere { <0, 0, 0>, 4.7+.6 } } 
  
     
    interior{ ior 1.05 media{ emission rgb<.2,.2,.2>*8 }}
    pigment { rgb 0 filter 0 transmit .25}
    finish {phong 1 phong_size 30 reflection 1 diffuse 0 ambient 0 }
    scale <1,1.2,1>
    translate pos1
      }       
#end

 

 

#if (r_athmosphere) 
 
    sphere { <0,0,0>,1.2
 
 
     hollow on                
  
	interior {
		media {
			method 3 samples 2+r_finerend intervals 2+r_finerend scattering {2, color rgb <1.0, 1.0, 1.0>*.12 extinction .7}                   //.005  7
			density {
						        average
			        density_map{
			        [.2 spherical scale .5]
			        [.2        
			        bozo
                                        turbulence 0.55
                                        octaves 5
                                        omega .4 //49876
                                        lambda 4.0 //2.5432
                                        color_map {
                                          [0.0 color rgb 0]    
                                          [0.3 color rgb .5]
                                          [0.4 color rgb 0 ]
                                          [0.5 color rgb .5 ]  
                                          [0.6 color rgb 1]
                                          [0.7 color rgb .5 ]
                                          [1.0 color rgb 0 ]  
                                          } scale 0.3  scale <.8,.4,.8> rotate <0,0,0>       //.014
    
                                ]}
                                } } 
		}  		
	 
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0} 
        scale 7    
      scale <2.2,1,2.2>
  translate pos1+<0,.4,0>
  
}     

      
#end
  
  
 
 #if (r_objects) 
 
 #declare leaf2ob=height_field { gif "blatt-eiche2.gif"  smooth        // smooth surface normal
  water_level 90/256 // truncate/clip below N (0.0 ... 1.0)
    hollow
   translate <0,0-90/256,0> scale <1,.05,1> rotate <0,-45,0> 
  }
 #declare t_ltree=
  texture {
    pigment {
      bozo
      color_map {  
        //[0.0 color rgb 1]
        [0.0 color rgb <0.4, 0.2, 0.30>]
        [0.2 color rgb <0.2, 0.5, 0.10> ]
        [0.4 color rgb <0.4, 0.6, 0.15> ]
        //[0.9 color rgb <0.4, 0.6, 0.15> ]
        [1 color rgb <0.4, 0.2, 0.05>*2 ]
                }
          scale 0.05
          warp { turbulence 0.9 }
            }
    finish {
      specular .1
      diffuse 0.5  //.9
      ambient 0  
      
      //reflection 0.02
           }
    normal {
      wrinkles 0.4
      scale 0.5
           }
          } 
 
  #declare ts_leafsize=.12;       //initializing Tree Sub Constants
 #declare ts_leaves_br=2;
 #declare ts_treetype=1;
 #declare ts_lengthf=.5;
 #declare ts_gravity=<0,-.02,0>;
#declare ts_doubranchprob=.5;
 #declare ts_staging=.5;
 #declare ts_angularity=.5;        
 #declare ts_spline=3;
 #declare ts_borke=0;
 #declare tsb_width=.014;
 #declare tsb_num=30;


 #declare ts_treetype=2;
 #declare ts_lengthf=.1;
 #declare ts_staging=.6;
 #declare ts_angularity=.7;  
 #local qdirvec=<0,.03,0>;
 #local qhrvec=<0,0,1>;
 #local qbrrad=.013;
 #local qbrleng=.09;
 #local qxwink=85;
 #local qdwink=65;
 #local qstage=30;

#if (r_zweige)
 #local qposvec=<-1,0,0>;
 #declare leaf2ob0=union{
 #declare ts_wood=1; //parse wood
 blob{
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
   texture { T_Wood2 scale .05 rotate <0,0,90> scale <1,3,1> translate qposvec}}
 #declare ts_wood=0; //parse leaves
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
 translate -qposvec
 rotate <0,30,0>
 rotate <90,0,0>
 }

 #local qstage=35;

 #local qposvec=<-2,0,0>;
 #declare leaf2ob1=union{
 #declare ts_wood=1; //parse wood
 blob{
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
   texture { T_Wood2 scale .05 rotate <0,0,90> scale <1,3,1> translate qposvec}}
 #declare ts_wood=0; //parse leaves
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
 translate -qposvec
 rotate <0,30,0>
 rotate <90,0,0>
 }
 
  #local qstage=28;

 #local qposvec=<-3,0,0>;
 #declare leaf2ob2=union{
 #declare ts_wood=1; //parse wood
 blob{
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
   texture { T_Wood2 scale .05 rotate <0,0,90> scale <1,3,1> translate qposvec}}
 #declare ts_wood=0; //parse leaves
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
 translate -qposvec
 rotate <0,30,0>
 rotate <90,0,0>
 }
 
  #local qstage=25;

 #local qposvec=<-4,0,0>;
 #declare leaf2ob3=union{
 #declare ts_wood=1; //parse wood
 blob{
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
   texture { T_Wood2 scale .05 rotate <0,0,90> scale <1,3,1> translate qposvec}}
 #declare ts_wood=0; //parse leaves
 twood(qposvec,qdirvec,qhrvec,qbrrad,qbrleng,qxwink,qdwink,qstage)
 translate -qposvec
 rotate <0,30,0>
 rotate <90,0,0>
 }
 #end  //r_zweige


 #declare ts_leafsize=2.2;       //initializing Tree Sub Constants
 #declare ts_leaves_br=1;
 #declare ts_treetype=1;
 #declare ts_lengthf=.5;
 #declare ts_gravity=<0,.02,0>;
 #declare ts_moreleaf=4;
 #declare ts_leafcnt=0;

 #declare ts_doubranchprob=.2;
 #declare ts_staging=.5;
 #declare ts_angularity=.5;        
 #declare ts_spline=8;
 #declare ts_wood=1; //parse wood
 #declare ts_borke=1;
 #declare tsb_width=.03;
 #declare tsb_num=40;






// #declare ts_spline=15;
// #declare ts_leaves_br=7;
//#declare ts_leafsize=.4;
#declare ts_doubranchprob=.65; 



// treetype: 1 faked leaves 2 leaves 3 clean 4 faked pine 5 pine with needles 6 normal tree with needles
    //tree(posvec,dir_vec,help_rot_vec,br_rad,br_leng,x_ang,rot_ang,stage,angularity,staging,lfactor,treetype)

#declare ts_gravity=<-0.004,0,0>;                                                                                                            

#if (r_trees)
#local pos1=<(504-512)*2/1.86 ,p_radius+70,(384-410)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
  tree(pos1,<.1,4,0>,<-.5,0,1>,.7,2.7,60,60, 260 ,.8,.6,.3,3-r_zweige)        

#declare ts_doubranchprob=.55; 
#declare ts_gravity=<0.004,0,0>;                                                                                                            
 #declare tsb_width=.03;
 #declare tsb_num=30;


#local pos1=<(525-512)*2/1.86 ,p_radius+70,(384-406)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
  tree(pos1,<.1,1.99,0>,<.3,0,1>,.50,2.2,74,74, 240 ,.8,.6,.3,3-r_zweige)        




 #declare tsb_num=20;
 #declare tsb_width=.04;
 #declare ts_spline=6;
 #declare ts_gravity=<0.004,0,0>;                                                                                                            
 
 
#local pos1=<(522-512)*2/1.86 ,p_radius+70,(384-398)*2/1.86>;
 #local pos1=positer(pos1);
  tree(pos1,<.1,1.99,0>,<-.19,0,1>,.50,2.3,74,74, 220 ,.8,.6,.3,3-r_zweige)        

 #declare ts_spline=4;
 #declare ts_borke=0;



#local pos1=<(512-512)*2/1.86 ,p_radius+70,(384-390)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
  tree(pos1,<.1,1.99,0>,<-.19,0,1>,.50,2.4,74,74, 200 ,.8,.6,.3,3-r_zweige)        


 
 #declare ts_leafsize=3;       //initializing Tree Sub Constants - Fllbume
 #declare ts_spline=2;
 #declare ts_borke=0;


#local pos1=<(500-512)*2/1.86 ,p_radius+70,(384-390)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
 
  tree(pos1,<0,1,0>,<0,0,1>,.50,3,74,74, 20 ,.8,.6,.3,3-r_zweige)        

#local pos1=<(520-512)*2/1.86 ,p_radius+70,(384-380)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
 
  tree(pos1,<0,1,0>,<0,0,1>,.50,3,74,74, 20 ,.8,.6,.3,3-r_zweige)        

 #local pos1=<(529-512)*2/1.86 ,p_radius+70,(384-394)*2/1.86>;
 #local pos1=positer(pos1)+<0,.1,0>;
 
  tree(pos1,<0,1,0>,<0,0,1>,.50,3,74,74, 20 ,.8,.6,.3,3-r_zweige)        

#end //r_trees



   #declare ts_gravity=<.004,0,0>;                                                                                                            
 #declare ts_spline=10;
 #declare ts_leaves_br=5;
#declare ts_leafsize=.3;
 #declare ts_doubranchprob=.68;
 #declare ts_moreleaf=0;
 #declare ts_leafcnt=0;      
 
   
 #local pos1=positer(pos1+<.5,0,-2.5>);
 
 
 #declare t_ltree=
  texture {
    pigment {
      bozo
      color_map {  
        //[0.0 color rgb 1]
        [0.0 color rgb <0.4, 0.3, 0.20>]
        [0.2 color rgb <0.2, 0.4, 0.10> ]
        [0.4 color rgb <0.6, 0.4, 0.35> ]
        //[0.9 color rgb <0.4, 0.6, 0.15> ]
        [1 color rgb <0.4, 0.4, 0.05>*2 ]
                }
          scale 0.05
          warp { turbulence 0.9 }
            }
    finish {
      specular .05
      diffuse 0.5  //.9
      ambient 0  
      
      //reflection 0.02
           }
    normal {
      wrinkles 0.2
      scale 0.5
           }
          } 

  #local pos1=positer(<(514-512)*2/1.86 ,p_radius+70,(384-406)*2/1.86>)+<0,1,0>;
 
  #declare xcnt=16;
   #while (xcnt>0)     
   

  #declare ycnt=7+xcnt*5;
  #debug concat("  parsing fallen leaves ",str(ycnt,4,0),"\n")
  #while (ycnt>0)   
   #declare pos2=pos1+vrotate(<0,0,4+xcnt/4>,<0,360*(ycnt+mod(xcnt,2)/2)/(7+xcnt*5),0>);
   #declare pos2=positer(pos2+<fnveg(pos2.x,pos2.y,pos2.z).red,70,fnveg(pos2.x,pos2.y,pos2.z).green>);
   #declare l_ang=720*fnveg(pos2.y*80,pos2.x*50,pos2.z*120).gray/2 ;
   #declare pos3=vnormalize(positer(pos2+vrotate(<0,0,ts_leafsize*2>,l_ang)+<0,70,0>)-pos2)*ts_leafsize;
   #declare pos4=vaxis_rotate(positer(pos2+vrotate(<ts_leafsize,0,0>,l_ang)+<0,70,0>)-pos2,pos3,90);
   leaf2 (pos2+<0,.02,0>,pos3,pos4)
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end 
 
 #local airfakt=1.5;
 #local pos1=pos1+<-9,2,-6>*airfakt;
   
#declare markers=array[2][16];
#declare marknum=array[2];  
   
#declare markers[1][1] =pos1+< 1  ,  2 , 0>*airfakt;
#declare markers[1][2] =pos1+< 5  , 1.5,-1>*airfakt;
#declare markers[1][3] =pos1+< 9  ,  1 , 0>*airfakt;
#declare markers[1][4] =pos1+< 12 , 0.5, 6>*airfakt;
#declare markers[1][5] =pos1+< 9  , 0.7,12>*airfakt;
#declare markers[1][6] =pos1+< 6  , 0.8, 6>*airfakt;
#declare markers[1][7] =pos1+< 9  , 0.7, 0>*airfakt;
#declare markers[1][8] =pos1+< 12 , 0.5, 6>*airfakt;
#declare markers[1][9] =pos1+< 9  , 0.2,12>*airfakt;
#declare markers[1][10]=pos1+< 6  , 00 , 6>*airfakt;
#declare markers[1][11]=pos1+< 9  , 0.2, 0>*airfakt;
#declare markers[1][12]=pos1+< 12 , 00 , 6>*airfakt;
#declare markers[1][13]=pos1+< 9  ,-0.5,12>*airfakt;
#declare markers[1][14]=pos1+< 6  ,-0.7, 6>*airfakt;
#declare markers[1][15]=pos1+< 9  ,-1.2, 0>*airfakt;
#declare marknum[1]=15; 

#declare ts_spline=11;

#local n_mark=1;
   
 #local c_max=marknum[n_mark];
 #local cnt=1; 
    
 #while (cnt<c_max)   
   #debug concat("  parsing floating leaves ",str(cnt,4,0),"\n")

    #local pos0=markers[n_mark][cnt];
    #local pos3=markers[n_mark][cnt+1];
    #local dirvec=pos3-pos0;
    #if (cnt>1)
     #local dirvec1=pos0-markers[n_mark][cnt-1];
    #else
     #local dirvec1=dirvec;
    #end
    #if (cnt<(c_max-1))
     #local dirvec2=pos3-markers[n_mark][cnt+2];
    #else
     #local dirvec2=-dirvec;
    #end 
        
    #local pos1=pos0;
    #local dia1=.2; 
    #local spleng=int(vlength(dirvec)/dia1*5);  
    #if (spleng>ts_spline) #local spleng=ts_spline; #end
    #local spcnt=spleng-1;                        
    #while (spcnt>-1)                 
     #local spraise=(spleng-spcnt)/spleng;
     #local spfall=spcnt/spleng;   
     #local vmdir=dirvec1*pow(spraise,2)*spfall+dirvec2*pow(spfall,2)*spraise;
     #local pos2=pos0+dirvec*spraise+vmdir/2;
     #local dia2=(1+c_max-abs(cnt-c_max/2)+spcnt/spleng)*.05;         
     #local dia=(dia1+dia2)*fnveg(pos1.z*20,pos1.x*20,pos1.y*20).gray;     
     #local l_ang=720*fnveg(pos2.y*30,pos2.x*40,pos2.z*40).green;
     #declare pos5=vnormalize(pos2-pos1)*ts_leafsize;                                                  
     #declare pos4=<pos5.y,pos5.z,-pos5.x>;
     #declare pos4=vnormalize(vaxis_rotate(pos4,pos5,l_ang));
     leaf2 (pos2+pos4*dia,pos5,pos4)
 
     #local pos1=pos2;
     #local dia1=dia2;
     #local spcnt=spcnt-1;
    #end           
    
  #local cnt=cnt+1;  
 #end
   
   
   
   #declare ts_gravity=<.004,0,0>;                                                                                                            
 #declare ts_spline=10;
 #declare ts_leaves_br=5;
#declare ts_leafsize=.3;
 #declare ts_doubranchprob=.68;
 #declare ts_moreleaf=0;
 #declare ts_leafcnt=0;      


    //bush 
 //  tree(positer(<(406.2-400)/1.86 ,p_radius,(300-425)/1.86 >),<0,.03,0>,<0,0,1>,.08,.35,32,110,180,1,.5,-.1,2)

  
  
  
  
#local pos1=<(514-512)*2/1.86 ,p_radius+70,(384-406)*2/1.86>;
      
 
   #declare xcnt=9;
   #while (xcnt>0)     
   

  #declare ycnt=7+xcnt*5;
  #debug concat("  parsing gras ",str(ycnt,4,0),"\n")
  #while (ycnt>0)   
   #declare pos2=pos1+vrotate(<0,0,5+xcnt/4>,<0,360*ycnt/(7+xcnt*5),0>);
   #declare pos2=positer(pos2+<fnveg(pos2.x,pos2.y,pos2.z).red,70,fnveg(pos2.x,pos2.y,pos2.z).green>);
   bgras(pos2,(1.5-xcnt*.1),.5,.05,12)
   #declare ycnt=ycnt-1;
  #end 
    #declare xcnt=xcnt-1;
   #end 
   
   
  #end   


  global_lights  
} //light_group
                                                   
                
 #if (r_athmosphere) 
  light_group{
  
   #local pos1=positer(<(514-512)*2/1.86 ,p_radius+70,(384-406)*2/1.86>)+<0,1,0>;
    difference{
    sphere { <0,0,0>,1
	 
    pigment {color rgb 1  transmit 1}
    finish {reflection 0 diffuse 0 ambient 1}   
  }
  sphere { <0,0,0>,.99
    hollow on                
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0} 
  }
      hollow on                
  
	interior {
		media {
			method 3 samples 1+r_finerend intervals 2 scattering {3, color rgb <1, .60, .40>*.10 extinction 0}                   //.005  7
			density {
				 spherical
                                } } 
		}  		

    scale 3200 
  translate pos1
  }
    difference{
    sphere { <0,0,0>,1
	 
    pigment {color rgb 1  transmit 1}
    finish {reflection 0 diffuse 0 ambient 1}   
  }
  sphere { <0,0,0>,.90
    hollow on                
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0} 
  }
      hollow on                
  
	interior {
		media {
			method 3 samples 2+r_finerend intervals 2 scattering {2, color rgb <1, 1, 1>*.001 extinction 6}                   //.005  7
			density {
			        bozo
                                        turbulence 0.55
                                        octaves 5
                                        omega .4 //49876
                                        lambda 4.0 //2.5432
                                        color_map {
                                          [0.0 color rgb 0] 
                                          [0.3 color rgb 0] 
                                            
                                          [0.4 color rgb .5]
                                          [0.5 color rgb 0 ]
                                          [0.6 color rgb .5 ]  
                                          [0.7 color rgb 1]
                                          [0.8 color rgb .5 ]
                                          [1.0 color rgb 0 ]  
                                          } scale 0.1  scale <2,.2,1> rotate <0,60,1>       //.014
                               
                                } } 
		}   		

    scale 1600 
  translate pos1
  }  

 light_source{ <-7000,17000,50000>+<-500,1000,-3000> color rgb r_sunpower/11
 parallel point_at cam_pos
 //shadowless
 }
 } //light_group


#end         //r_athmosphere


 translate <0,-p_radius,0>
 }  //union "geocentric world"
  

// light_source{ cam_look+<000,1000,000> color rgb r_sunpower/10
 light_source{ <-7000,17000,50000>+<-500,1000,-3000> color rgb <1,.88,.7>*r_sunpower/5
 parallel point_at cam_pos
 shadowless
 }
 


 
light_group{ 

 light_source{ <-7000,17000,50000>-<50000,7000,-3500> color rgb <1,.75,.4>*r_sunpower*10 
           parallel
  point_at   <-7000,17000,50000>
  //shadowless
 
 
 }          
 //sphere { <-7000,17000,50000>-<500000,70000,-15000>,3000 }
 
 
#if (r_otherplanets)
// the moon
  #declare fnmoo=   // Terrain shape function
  function{
    pigment {
      agate
      color_map {
        [0 color rgb 0]
        [1 color rgb 1]
      }
      scale .03 
      translate <0,0, 0>
    }
  }



union{          

// the dust
/* sphere { <0,0,0>,1
    hollow on                
  
	interior {
		media {
			method 3
			samples 2 intervals 2
			scattering {4, color rgb .0001 extinction .5} 
			//absorption rgb < 0.1, 0.1, 0.1>*.05    
			density { spherical } 
		}  		
	} 
    pigment {color rgb 0  transmit 1}
    finish {reflection 0 diffuse 0 ambient 0}   
    scale 1.15
  } */
           
 // the moon
   isosurface {
    function { f_sphere(x, y, z, 1)+(1-fnmoo(x, y, z).gray*(.5-abs(.5-fnmoo(x/20, y/20, z/20).gray)))/90 }
    max_gradient 9
    evaluate 2, 1.2, 0.95    // for evaluating max_gradient
    accuracy 0.02
    contained_by { sphere { <0, 0, 0>, 1.01 } }  
   texture {
   pigment { color rgb <1.0, 1.0, 1.0>*.05 }
  finish { 
    diffuse 0.8   
   }
  normal {
    granite .1
    scale 0.03
  }  
}
  }  
  scale <1,.85,1>         
  scale 3000
   translate <-7000,17000,50000>      
} // union moon
} //lightgroup            
            
  #declare R1 = seed(0);
  #declare R2 = seed(12);
  #declare R3 = seed(452);
  #declare R4 = seed(782);
  #declare scnt=200;  
  #declare snum=scnt;
   #while (scnt>0)       
    
    #declare sposx=rand(R1);
    #declare sposy=rand(R2);
    #declare ssize=rand(R3);
    #declare scol=0.5+pow(rand(R4)*2-1,3)/2;
    
    
    sphere {<0,15000,60000>, pow((ssize)*8,2)+8    
    
    rotate <sposy*30-15,0,0>
    rotate <0,sposx*100-50,0>

    pigment { color rgb <1.2-scol/5, 1,.8+scol/5> }
    finish {reflection 0 diffuse 0 ambient .02+ssize}   
    }
   
   
   
 
   
    #declare scnt=scnt-1;
   #end

#end
